// FastTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FastTest.h"
#include "FastTestDlg.h"
#include <rscmu2bt.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	char buffer[512]; 
// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFastTestDlg dialog

CFastTestDlg::CFastTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFastTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFastTestDlg)
	m_ressString = _T("GPIB0::20::0::INSTR");
	m_RXBurst = 0;
	m_TXBurst = 0;
	m_channelSelect = 0;
	m_dut = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
}

void CFastTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFastTestDlg)
	DDX_Control(pDX, IDC_REC_LIST, m_recList);
	DDX_Control(pDX, IDC_DUT, m_dutComboBox);
	DDX_Control(pDX, IDC_TABLE, m_table);
	DDX_Text(pDX, IDC_RESSOURCE_STRING, m_ressString);
	DDX_Text(pDX, IDC_RX_BURST, m_RXBurst);
	DDX_Text(pDX, IDC_TX_BURST, m_TXBurst);
	DDX_CBIndex(pDX, IDC_CHANNEL_SELECT, m_channelSelect);
	DDX_CBIndex(pDX, IDC_DUT, m_dut);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFastTestDlg, CDialog)
	//{{AFX_MSG_MAP(CFastTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RUN, OnRun)
	ON_BN_CLICKED(IDC_SCAN, OnScan)
	ON_CBN_SELCHANGE(IDC_CHANNEL_SELECT, OnSelchangeChannelSelect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFastTestDlg message handlers

BOOL CFastTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//Init Arrays
	long i,j;
	for (i=0;i<6;i++)
		for (j=0;j<4;j++)
		{
			nominalPower[i][j] = 0.0;
			leakagePower[i][j] = 0.0;
			peakPower[i][j] = 0.0;
			packetTiming[i][j] = 0;
			frequencyAccuracy[i][j] = 0.0;
			frequencyDrift[i][j] = 0.0;
			maxDriftRate[i][j] = 0.0;
			avgFreqDeviation[i][j] = 0.0;
			minFreqDeviation[i][j] = 0.0;
			maxFreqDeviation[i][j] = 0.0;
			burstOutofTolPower[i][j] = 0.0;
			burstOutofTolTiming[i][j] = 0.0;
			burstOutofTolModulation[i][j] = 0.0;
		}
	for (i=0;i<3;i++)
	{
		ber_data[i] = 0.0;
		per_data[i] = 0.0;
		packet_received[i] = 0;
	}

	//Init Table
	CString text;
	
	text.Format ("Parameter");
	m_table.InsertColumn(0, text, LVCFMT_LEFT, 140);
	text.Format ("Current");
	m_table.InsertColumn(1, text, LVCFMT_LEFT, 56);
	text.Format ("Average");
	m_table.InsertColumn(2, text, LVCFMT_LEFT, 56);
	text.Format ("Minimum");
	m_table.InsertColumn(3, text, LVCFMT_LEFT, 56);
	text.Format ("Maximum");
	m_table.InsertColumn(4, text, LVCFMT_LEFT, 57);

	//Insert first column items
	LVITEM		t_item;
	t_item.mask = LVIF_TEXT | LVIF_STATE;
	t_item.iSubItem = 0;
	t_item.stateMask = LVIS_SELECTED;
	t_item.state = 0;
	t_item.iImage = 0;
	t_item.lParam = 0;

	t_item.iItem = 0;	
	text.Format ("Nominal Power");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 1;	
	text.Format ("Leakage Power");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 2;	
	text.Format ("Peak Power");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 3;	
	text.Format ("Packet Timing");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 4;	
	text.Format ("Frequency Accurancy");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 5;	
	text.Format ("Frequency Drift");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 6;	
	text.Format ("Max Drift Rate");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 7;	
	text.Format ("Avg Freq Deviation");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 8;	
	text.Format ("Min Freq Deviation");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 9;	
	text.Format ("Max Freq Deviation");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 10;	
	text.Format ("Burst Out Of Tol Power");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 11;	
	text.Format ("Burst Out Of Timing");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);
	t_item.iItem = 12;	
	text.Format ("Burst Out Of Tol Modulation");
	t_item.pszText = text.GetBuffer(0);
	i = m_table.InsertItem(&t_item);

	//Init RecList
	text.Format ("Channel");
	m_recList.InsertColumn(0, text, LVCFMT_LEFT, 60);
	text.Format ("BER");
	m_recList.InsertColumn(1, text, LVCFMT_LEFT, 50);
	text.Format ("PER");
	m_recList.InsertColumn(2, text, LVCFMT_LEFT, 50);
	text.Format ("Packet Received");
	m_recList.InsertColumn(4, text, LVCFMT_LEFT, 100);
	
	//Insert first column items
	t_item.mask = LVIF_TEXT | LVIF_STATE;
	t_item.iSubItem = 0;
	t_item.stateMask = LVIS_SELECTED;
	t_item.state = 0;
	t_item.iImage = 0;
	t_item.lParam = 0;

	t_item.iItem = 0;	
	text.Format ("00");
	t_item.pszText = text.GetBuffer(0);
	i = m_recList.InsertItem(&t_item);
	t_item.iItem = 1;	
	text.Format ("39");
	t_item.pszText = text.GetBuffer(0);
	i = m_recList.InsertItem(&t_item);
	t_item.iItem = 2;	
	text.Format ("78");
	t_item.pszText = text.GetBuffer(0);
	i = m_recList.InsertItem(&t_item);

	//Default Value for RX and TX Bursts
	m_RXBurst = 20;
	m_TXBurst = 5;

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFastTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFastTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFastTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFastTestDlg::OnRun() 
{
	long	 	signalling_state; 
	long	 	i;
	char		buffer[512];

	
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );

	rscmu_status = RSCMU_init ((char *) ((LPCTSTR) m_ressString), VI_TRUE, VI_FALSE, &vi_base);
	if (rscmu_status < 0)
	{
		AfxMessageBox ("Could not open base session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}	
	FT_CHECKRET (RSCMU_Base_SystRemAddrSec(vi_base, 1, RSCMU_BLUETOOTH_SIG, error_message));
	FT_CHECKRET (RSCMUBT_Init_BT_Sig (vi_base, &vi_2bt, error_message));
	m_dutComboBox.GetLBText(m_dut, buffer);
	FT_CHECKRET (RSCMUBT_Sig_ConfMsigPagTarg(vi_2bt, buffer, error_message));
    FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTsetDel(vi_2bt, 1, RSCMU_OFF, error_message));
    FT_CHECKRET (RSCMUBT_Sig_ConfMsigPagPsrm(vi_2bt, 1, error_message));
    FT_CHECKRET (RSCMUBT_Sig_ConfMsigPagRsin(vi_2bt, RSCMU_ON, error_message));
    
	FT_CHECKRET(RSCMUBT_Sig_ProcSignAct(vi_2bt, 3, error_message));

	do{
		
		rscmu_status = RSCMUBT_Sig_SensXSignStat(vi_2bt, &signalling_state, error_message);
		if (signalling_state == 0)
		{
			rscmu_status = -1;
			strcpy(error_message, "Could not establish the connection.");     
		}
	}while ((signalling_state != 4) && (rscmu_status >=0));
 
	FT_CHECKRET (RSCMUBT_Sig_ConfPowMprContStat(vi_2bt, m_TXBurst, error_message));
    FT_CHECKRET (RSCMUBT_Sig_ConfPowMprContRep(vi_2bt, RSCMU_SINGLE_SHOT, RSCMU_NONE, RSCMU_NONE, error_message));
    FT_CHECKRET (RSCMUBT_Sig_ConfPowMprMmod(vi_2bt, 0, error_message));
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTmty(vi_2bt, 0, 1, error_message));
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodHsch(vi_2bt, 0, 5, error_message));
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtPtyp(vi_2bt, 0, 2, error_message));
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtLots(vi_2bt, 0, 2, 339, error_message));
    

    //Tx Channel 0 
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtChan(vi_2bt, 0, 0, error_message));
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtPatt(vi_2bt, 1, 3, error_message));    
    FT_CHECKRET (RSCMUBT_Sig_InitPowMpr(vi_2bt, error_message));
    for (i=0;i<=3;i++)
        FT_CHECKRET (RSCMUBT_Sig_FetcPowMpr(vi_2bt, i, &nominalPower[0][i], &leakagePower[0][i], &peakPower[0][i], &packetTiming[0][i], &frequencyAccuracy[0][i], &frequencyDrift[0][i], &maxDriftRate[0][i], &avgFreqDeviation[0][i], &minFreqDeviation[0][i], &maxFreqDeviation[0][i], &burstOutofTolPower[0][i], &burstOutofTolTiming[0][i], &burstOutofTolModulation[0][i], error_message));
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtPatt(vi_2bt, 1, 4, error_message));
    FT_CHECKRET (RSCMUBT_Sig_InitPowMpr(vi_2bt, error_message));
    for (i=0;i<=3;i++)
        FT_CHECKRET (RSCMUBT_Sig_FetcPowMpr(vi_2bt, i, &nominalPower[1][i], &leakagePower[1][i], &peakPower[1][i], &packetTiming[1][i], &frequencyAccuracy[1][i], &frequencyDrift[1][i], &maxDriftRate[1][i], &avgFreqDeviation[1][i], &minFreqDeviation[1][i], &maxFreqDeviation[1][i], &burstOutofTolPower[1][i], &burstOutofTolTiming[1][i], &burstOutofTolModulation[1][i], error_message));
    
    //Tx Channel 39 
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtChan (vi_2bt, RSCMU_CONF, 39, error_message));
    FT_CHECKRET (RSCMUBT_Sig_InitPowMpr(vi_2bt, error_message));
    for (i=0;i<=3;i++)
        FT_CHECKRET (RSCMUBT_Sig_FetcPowMpr(vi_2bt, i, &nominalPower[3][i], &leakagePower[3][i], &peakPower[3][i], &packetTiming[3][i], &frequencyAccuracy[3][i], &frequencyDrift[3][i], &maxDriftRate[3][i], &avgFreqDeviation[3][i], &minFreqDeviation[3][i], &maxFreqDeviation[3][i], &burstOutofTolPower[3][i], &burstOutofTolTiming[3][i], &burstOutofTolModulation[3][i], error_message));
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtPatt(vi_2bt, 1, 3, error_message));
    FT_CHECKRET (RSCMUBT_Sig_InitPowMpr(vi_2bt, error_message));
    for (i=0;i<=3;i++)
        FT_CHECKRET (RSCMUBT_Sig_FetcPowMpr(vi_2bt, i, &nominalPower[2][i], &leakagePower[2][i], &peakPower[2][i], &packetTiming[2][i], &frequencyAccuracy[2][i], &frequencyDrift[2][i], &maxDriftRate[2][i], &avgFreqDeviation[2][i], &minFreqDeviation[2][i], &maxFreqDeviation[2][i], &burstOutofTolPower[2][i], &burstOutofTolTiming[2][i], &burstOutofTolModulation[2][i], error_message));

    //Tx Channel 78 
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtChan (vi_2bt, RSCMU_CONF, 78, error_message));
    FT_CHECKRET (RSCMUBT_Sig_InitPowMpr(vi_2bt, error_message));
    for (i=0;i<=3;i++)
        FT_CHECKRET (RSCMUBT_Sig_FetcPowMpr(vi_2bt, i, &nominalPower[4][i], &leakagePower[4][i], &peakPower[4][i], &packetTiming[4][i], &frequencyAccuracy[4][i], &frequencyDrift[4][i], &maxDriftRate[4][i], &avgFreqDeviation[4][i], &minFreqDeviation[4][i], &maxFreqDeviation[4][i], &burstOutofTolPower[4][i], &burstOutofTolTiming[4][i], &burstOutofTolModulation[4][i], error_message));
    FT_CHECKRET (RSCMUBT_Sig_SsigTmodTxtPatt(vi_2bt, 1, 4, error_message));
    FT_CHECKRET (RSCMUBT_Sig_InitPowMpr(vi_2bt, error_message));
    for (i=0;i<=3;i++)
        FT_CHECKRET (RSCMUBT_Sig_FetcPowMpr(vi_2bt, i, &nominalPower[5][i], &leakagePower[5][i], &peakPower[5][i], &packetTiming[5][i], &frequencyAccuracy[5][i], &frequencyDrift[5][i], &maxDriftRate[5][i], &avgFreqDeviation[5][i], &minFreqDeviation[5][i], &maxFreqDeviation[5][i], &burstOutofTolPower[5][i], &burstOutofTolTiming[5][i], &burstOutofTolModulation[5][i], error_message));

    FT_CHECKRET (RSCMUBT_Sig_AborPowMpr(vi_2bt, error_message));
    
    //Recevier test
    FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerLev(vi_2bt, 1, -70.0, error_message));
    FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTsetPtyp(vi_2bt, 1, 2, error_message));
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTsetLots(vi_2bt, 1, 2, 339, error_message));
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTsetHsch(vi_2bt, 1, 5, error_message));
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTsetPatt(vi_2bt, 1, 1, error_message));
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerContRep(vi_2bt, 1, RSCMU_SINGLE_SHOT, RSCMU_NONE, RSCMU_NONE, error_message));
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerContStat(vi_2bt, 1, m_TXBurst, error_message));
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTset(vi_2bt, 1, error_message));

    //BER Channel 0
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTsetChan(vi_2bt, 1, 0, 78, error_message));
	FT_CHECKRET (RSCMUBT_Sig_InitRxqBer(vi_2bt, error_message));
	FT_CHECKRET (RSCMUBT_Sig_FetcRxqBer(vi_2bt, &ber_data[0], &per_data[0], &packet_received[0], error_message));
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTsetChan(vi_2bt, 1, 39, 0, error_message));
	FT_CHECKRET (RSCMUBT_Sig_InitRxqBer(vi_2bt, error_message));
	FT_CHECKRET (RSCMUBT_Sig_FetcRxqBer(vi_2bt, &ber_data[1], &per_data[1], &packet_received[1], error_message));
	FT_CHECKRET (RSCMUBT_Sig_ConfRxqBerTsetChan(vi_2bt, 1, 78, 0, error_message));
	FT_CHECKRET (RSCMUBT_Sig_InitRxqBer(vi_2bt, error_message));
	FT_CHECKRET (RSCMUBT_Sig_FetcRxqBer(vi_2bt, &ber_data[2], &per_data[2], &packet_received[2], error_message));
    FT_CHECKRET (RSCMUBT_Sig_ProcSignAct(vi_2bt, 6, error_message));
    FT_CHECKRET (RSCMUBT_Sig_ProcSignAct(vi_2bt, 5, error_message));
	RSCMUBT_close(vi_2bt);
    RSCMU_close(vi_base);
    if (rscmu_status < 0)
    {
        sprintf (buffer, "Error: %ld, %s", rscmu_status, error_message);
        AfxMessageBox ("Could not open base session!", MB_OK);
    }
    UpdateTables();
	
	cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor ( cur );
}

void CFastTestDlg::OnScan() 
{
	long 			nb_of_devices;
#if defined SRQ_ENABLED
	unsigned short 	garbage;
#else
	unsigned short 	stb;
#endif
	char			buffer[512];
	char			*p_token;
	char			p_tmp[512];
	int				i, time, delay_step;

	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );

	rscmu_status = RSCMU_init ((char *) ((LPCTSTR) m_ressString), VI_TRUE, VI_FALSE, &(vi_base));

	if (rscmu_status < 0)
	{
		AfxMessageBox ("Could not open base session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}
	FT_CHECKRET (RSCMU_Base_SystRemAddrSec(vi_base, 1, RSCMU_BLUETOOTH_SIG, error_message));
    FT_CHECKRET (RSCMUBT_Init_BT_Sig(vi_base, &vi_2bt, error_message));
	
	 //configure status subsystem to generate SRQ
	FT_CHECKERR (viWrite(vi_base, (unsigned char *)"*SRE 128", 8, 0), "Unable to set status registers!");
    
    FT_CHECKRET (RSCMU_Base_StatOperCmuSumCmuEnab(vi_base, RSCMU_SUM1, 2, 8, error_message));
	FT_CHECKRET (RSCMU_Base_StatOperCmuSumEnab(vi_base, RSCMU_SUM1, 2, error_message));
	FT_CHECKRET (RSCMU_Base_StatOperEnab(vi_base, 511, error_message));

#if defined SRQ_ENABLED
	FT_CHECKRET (viEnableEvent(vi_2bt, VI_EVENT_SERVICE_REQ, VI_QUEUE, 0));
#endif

	//start inquiry
	FT_CHECKRET (RSCMUBT_Sig_ProcSignAct(vi_2bt, 0, error_message));

#if defined SRQ_ENABLED
	FT_CHECKERR (viWaitOnEvent(vi_2bt, VI_ALL_ENABLED_EVENTS, 20000, 0, 0), "No DUT found!");
  
	FT_CHECKRET (viDiscardEvents(vi_2bt, VI_ALL_ENABLED_EVENTS, VI_QUEUE));

	FT_CHECKRET (viReadSTB(vi_base, &garbage));
#else
	delay_step = 10;
	time = 0;
	do
	{
		FT_CHECKRET (viReadSTB(vi_base, &stb));
		Sleep (delay_step);
		time += delay_step;
	} while (!((stb & 0x40) || (time > 20000)));
#endif


    FT_CHECKRET (RSCMUBT_Sig_FetcSignPtar(vi_2bt, &nb_of_devices, buffer, error_message));
	
	m_dutComboBox.ResetContent();
	
	i=0;
	
    p_token = strstr (buffer, "BD01");
    if (p_token != VI_NULL)
    {
    	p_token = strtok (p_token,",");
    	p_token = strtok (NULL, ",");
    	sscanf (p_token, "\"%[^\"]\"", p_tmp);
		m_dutComboBox.InsertString (-1, p_tmp);
    	for (i=1;i<nb_of_devices;i++)
    	{
    		p_token = strtok (NULL, ",");
    		p_token = strtok (NULL, ",");
    		sscanf (p_token, "\"%[^\"]\"", p_tmp); 
	        m_dutComboBox.InsertString (-1, p_tmp);
    	}   
    }
	
	//FT_CHECKRET (RSCMUBT_Sig_ProcSignAct(vi_2bt, 1, error_message));
	RSCMUBT_close(vi_2bt);
    RSCMU_close(vi_base);
    if (rscmu_status < 0)
    {
        sprintf (buffer, "Error: %ld, %s", rscmu_status, error_message);
        AfxMessageBox ("Could not open base session!", MB_OK);
	}
	m_dut = 0;
	UpdateData (FALSE);

	cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor ( cur );
}

int CFastTestDlg::UpdateTables()
{
	long j;
	CString str;
	//Update Table		
	for (j=0;j<4;j++)
	{
		if (nominalPower[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",nominalPower[m_channelSelect][j]);
		m_table.SetItemText(0, j+1, str);

		if (leakagePower[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",leakagePower[m_channelSelect][j]);
		m_table.SetItemText(1, j+1, str);

		if (peakPower[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",peakPower[m_channelSelect][j]);
		m_table.SetItemText(2, j+1, str);

		if (packetTiming[m_channelSelect][j] == RSCMU_NAN_VI_INT32)
			str = "-.-";
		else
			str.Format("%d",packetTiming[m_channelSelect][j]);
		m_table.SetItemText(3, j+1, str);

		if (frequencyAccuracy[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",frequencyAccuracy[m_channelSelect][j]);
		m_table.SetItemText(4, j+1, str);

		if (frequencyDrift[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",frequencyDrift[m_channelSelect][j]);
		m_table.SetItemText(5, j+1, str);

		if (maxDriftRate[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",maxDriftRate[m_channelSelect][j]);
		m_table.SetItemText(6, j+1, str);

		if (avgFreqDeviation[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",avgFreqDeviation[m_channelSelect][j]);
		m_table.SetItemText(7, j+1, str);

		if (minFreqDeviation[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",minFreqDeviation[m_channelSelect][j]);
		m_table.SetItemText(8, j+1, str);

		if (maxFreqDeviation[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",maxFreqDeviation[m_channelSelect][j]);
		m_table.SetItemText(9, j+1, str);

		if (burstOutofTolPower[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",burstOutofTolPower[m_channelSelect][j]);
		m_table.SetItemText(10, j+1, str);

		if (burstOutofTolTiming[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",burstOutofTolTiming[m_channelSelect][j]);
		m_table.SetItemText(11, j+1, str);

		if (burstOutofTolModulation[m_channelSelect][j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",burstOutofTolModulation[m_channelSelect][j]);
		m_table.SetItemText(12, j+1, str);
	}
	//Update receiver table
	for (j=0;j<3;j++)
	{
		if (ber_data[j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",ber_data[j]);
		m_recList.SetItemText(j, 1, str);

		if (per_data[j] == RSCMU_NAN)
			str = "-.-";
		else
			str.Format("%.2f",per_data[j]);
		m_recList.SetItemText(j, 2, str);

		if (packet_received[j] == RSCMU_NAN_VI_INT32)
			str = "-.-";
		else
		str.Format("%d",packet_received[j]);
		m_recList.SetItemText(j, 3, str);
	}
	return 0;
}

void CFastTestDlg::OnSelchangeChannelSelect() 
{
	UpdateTables();	
}
